// VidCapPlusView.cpp : implementation of the CVidCapPlusView class
//

#include "stdafx.h"
#include "VidCapPlus.h"

#include "VidCapPlusDoc.h"
#include "VidCapPlusView.h"

#include "WarnDialog.h"
#include "VideoCapParams.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CVidCapPlusView

IMPLEMENT_DYNCREATE(CVidCapPlusView, CScrollView)

BEGIN_MESSAGE_MAP(CVidCapPlusView, CScrollView)
	//{{AFX_MSG_MAP(CVidCapPlusView)
	ON_COMMAND(ID_OPTIONS_AUDIOFORMAT, OnOptionsAudioformat)
	ON_COMMAND(ID_OPTIONS_VIDEO_FORMAT, OnOptionsVideoFormat)
	ON_COMMAND(ID_OPTIONS_VIDEO_SOURCE, OnOptionsVideoSource)
	ON_COMMAND(ID_OPTIONS_VIDEO_DISPLAY, OnOptionsVideoDisplay)
	ON_COMMAND(ID_OPTIONS_VIDEO_COMPRESSION, OnOptionsVideoCompression)
	ON_COMMAND(ID_OPTIONS_PREVIEW, OnOptionsPreview)
	ON_COMMAND(ID_OPTIONS_OVERLAY, OnOptionsOverlay)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_AUDIOFORMAT, OnUpdateOptionsAudioformat)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_VIDEO_FORMAT, OnUpdateOptionsVideoFormat)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_VIDEO_SOURCE, OnUpdateOptionsVideoSource)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_VIDEO_DISPLAY, OnUpdateOptionsVideoDisplay)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_VIDEO_COMPRESSION, OnUpdateOptionsVideoCompression)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_PREVIEW, OnUpdateOptionsPreview)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_OVERLAY, OnUpdateOptionsOverlay)
	ON_WM_PAINT()
	ON_COMMAND(ID_EDIT_COPY, OnEditCopy)
	ON_COMMAND(ID_CAPTURE_SINGLEFRAME, OnCaptureSingleframe)
	ON_COMMAND(ID_CAPTURE_VIDEO, OnCaptureVideo)
	ON_COMMAND(ID_CAPTURE_PALETTE, OnCapturePalette)
	ON_COMMAND(ID_FILE_SETCAPTUREFILE, OnFileSetcapturefile)
	ON_COMMAND(ID_FILE_SAVESINGLEFRAME, OnFileSavesingleframe)
	ON_UPDATE_COMMAND_UI(ID_CAPTURE_SINGLEFRAME, OnUpdateCaptureSingleframe)
	ON_COMMAND(ID_EDIT_PASTEPALLETE, OnEditPastepallete)
	ON_UPDATE_COMMAND_UI(ID_EDIT_PASTEPALLETE, OnUpdateEditPastepallete)
	ON_UPDATE_COMMAND_UI(ID_EDIT_COPY, OnUpdateEditCopy)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVidCapPlusView construction/destruction

CVidCapPlusView::CVidCapPlusView()
{
	// TODO: add construction code here
	bCreated=FALSE;
	bPreview=1;
	bOverlay=1;
}

CVidCapPlusView::~CVidCapPlusView()
{
}

BOOL CVidCapPlusView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CScrollView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CVidCapPlusView drawing

void CVidCapPlusView::OnDraw(CDC* pDC)
{
	CVidCapPlusDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	// TODO: add draw code for native data here
}

void CVidCapPlusView::OnInitialUpdate()
{
	//CScrollView::OnInitialUpdate();
	CRect rc;
	GetClientRect(&rc);
	rc.left=0;
	rc.top=0;
	rc.bottom=30;
	rc.right=30;

	if (!CapWnd.Create(NULL, WS_CHILD | WS_VISIBLE
							 ,1,rc,this))
	{
		//Nismo uspeli da napravimo prozor
		CWarnDialog dlg;
		if (dlg.DoModal()==IDOK)
		{	
			PostQuitMessage(0);
			return;
		}
	}
		
	CString DriverName=CapWnd.GetDriverDescription(0);
	if (DriverName==CString("NULL"))
	{
		// Izgleda da nema drjavera i kartice za Capture!
		CWarnDialog dlg;
		if (dlg.DoModal()==IDOK)
			PostQuitMessage(0);
			bPreview=0;
			bOverlay=0;
			return;
	}
		

	if (!CapWnd.InitHardware())
	{
		AfxMessageBox("Ne merem da se konektujem :(",MB_OK,NULL);
		CWarnDialog dlg;
		if (dlg.DoModal()==IDOK)
			PostQuitMessage(0);
		return;
	}
	if (CapWnd.bOverlay)
	{
		bPreview=2;
		CapWnd.PreviewRate(0);
		bOverlay=1;
	}
	else
	{
		bOverlay=2;
		if (CapWnd.bLive)
		{
			bPreview=1;
			CapWnd.PreviewRate(33);
		}
		else
		{
			bPreview=2;
			CapWnd.PreviewRate(0);
		}
		
	}
	if (!CapWnd.HasOverlay()) bOverlay=0;
	bCreated=TRUE;
	
	//pronasli smo driver i konektovali se te zelimo da njegovo ime 
	//smestimo u meni kao informaciju
	
	CWnd* pMainWnd=AfxGetMainWnd();
	CMenu* pMasterMenu=pMainWnd->GetMenu();
	CMenu* pOptionsMenu=pMasterMenu->GetSubMenu(2);
	pOptionsMenu->ModifyMenu(ID_OPTIONS_DRIVER,MF_BYCOMMAND|MF_CHECKED,0,DriverName);
	
	CVidCapPlusDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	pDoc->SetTitle(CapWnd.CaptureFile);

	ResizeView();
}

/////////////////////////////////////////////////////////////////////////////
// CVidCapPlusView diagnostics

#ifdef _DEBUG
void CVidCapPlusView::AssertValid() const
{
	CScrollView::AssertValid();
}

void CVidCapPlusView::Dump(CDumpContext& dc) const
{
	CScrollView::Dump(dc);
}

CVidCapPlusDoc* CVidCapPlusView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CVidCapPlusDoc)));
	return (CVidCapPlusDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CVidCapPlusView message handlers


void CVidCapPlusView::OnFileSetcapturefile() 
{
	// TODO: Add your command handler code here
	LPSTR i;
	char Buffer[_MAX_PATH];
	lstrcpy (Buffer, CapWnd.CaptureFile);
        for (i = Buffer + lstrlen(Buffer); i > Buffer; i--) 
		{
            if (*i == '\\') 
			{
                *(i+1) = '\0';
                break;
            }
        }

	
	CFileDialog	dlg(TRUE,NULL,CapWnd.CaptureFile,OFN_NONETWORKBUTTON
					|OFN_HIDEREADONLY,
					"Microsoft Avi(*.avi)|*.avi|AllFiles (*.*)|*.*||",NULL);

	dlg.m_ofn.lpstrTitle = "Select Capture File";
	dlg.m_ofn.lpstrInitialDir=Buffer;

	if (dlg.DoModal()==IDOK)
	{ 
		CString aviName;
		aviName=dlg.GetPathName();
		if (dlg.GetFileExt().IsEmpty()) aviName=aviName+".avi";
		CapWnd.FileSetCaptureFile(LPCTSTR(aviName));
		lstrcpy(CapWnd.CaptureFile,LPCTSTR(dlg.GetPathName()));
		
		CVidCapPlusDoc* pDoc = GetDocument();
		ASSERT_VALID(pDoc);
		pDoc->SetTitle(CapWnd.CaptureFile);

	}


}

void CVidCapPlusView::OnFileSavesingleframe() 
{
	// TODO: Add your command handler code here
	CFileDialog	dlg(TRUE,NULL,NULL,OFN_NONETWORKBUTTON
					|OFN_HIDEREADONLY,
					"Microsoft Windows DIB (*.bmp)|*.bmp",NULL);

	dlg.m_ofn.lpstrTitle = "Select Capture Frame File Name";

	if (dlg.DoModal()==IDOK)
	{ 
		CString bmpName;
		bmpName=dlg.GetPathName();
		if (dlg.GetFileExt().IsEmpty()) bmpName=bmpName+".bmp";
		CapWnd.FileSaveDIB(LPCTSTR(bmpName));
	}

}


void CVidCapPlusView::OnEditCopy() 
{
	// TODO: Add your command handler code here
	CapWnd.EditCopy();	
}

void CVidCapPlusView::OnEditPastepallete() 
{
	// TODO: Add your command handler code here
	CapWnd.PalettePaste();
}


void CVidCapPlusView::OnOptionsAudioformat() 
{
	// TODO: Add your command handler code here
	DWORD dwSize;
	WAVEFORMATEX wform ;
	ACMFORMATCHOOSE acfmt;
    acmMetrics(NULL,ACM_METRIC_MAX_SIZE_FORMAT,&dwSize);
    dwSize = max (dwSize, CapWnd.GetAudioFormatSize ());
    CapWnd.GetAudioFormat(wform);
    memset (&acfmt, 0, sizeof (ACMFORMATCHOOSE));
    acfmt.cbStruct = sizeof (ACMFORMATCHOOSE);
	acfmt.fdwStyle =  ACMFORMATCHOOSE_STYLEF_INITTOWFXSTRUCT;
	acfmt.fdwEnum =   ACM_FORMATENUMF_HARDWARE |
                     ACM_FORMATENUMF_INPUT;
	acfmt.hwndOwner = CapWnd.m_hWnd;
	acfmt.pwfx =     &wform;
	acfmt.cbwfx =    dwSize;
    if (!acmFormatChoose(&acfmt)) 
	{
		 CapWnd.SetAudioFormat(wform) ;
	}
                
}

void CVidCapPlusView::OnOptionsVideoFormat() 
{
	// TODO: Add your command handler code here
	CapWnd.DlgVideoFormat();	
	CapWnd.ResizeWnd();
	ResizeView();
	
}

void CVidCapPlusView::OnOptionsVideoSource() 
{
	// TODO: Add your command handler code here
	CapWnd.DlgVideoSource();
	CapWnd.ResizeWnd();

}

void CVidCapPlusView::OnOptionsVideoDisplay() 
{
	// TODO: Add your command handler code here
	CapWnd.DlgVideoDisplay();
	CapWnd.ResizeWnd();	
}

void CVidCapPlusView::OnOptionsVideoCompression() 
{
	// TODO: Add your command handler code here
	CapWnd.DlgVideoCompression();
	CapWnd.ResizeWnd();
}

void CVidCapPlusView::OnOptionsPreview() 
{
	// TODO: Add your command handler code here
	if (bPreview==1) 
	{
		bPreview=2;
		CapWnd.Preview(FALSE);
		CapWnd.bLive=FALSE;
		CapWnd.bOverlay=FALSE;
	}
	else 
		if (bPreview==2) 
		{
			bPreview=1;
			bOverlay=2;
			CapWnd.Overlay(FALSE);
			CapWnd.PreviewRate(33);
			CapWnd.Preview(TRUE);
			CapWnd.bLive=TRUE;
			CapWnd.bOverlay=FALSE;
		}
}

void CVidCapPlusView::OnOptionsOverlay() 
{
	// TODO: Add your command handler code here
	if (bOverlay==1) 
	{
		bOverlay=2;
		CapWnd.Overlay(FALSE);
		CapWnd.bOverlay=FALSE;
		CapWnd.PreviewRate(33);
		CapWnd.bLive=FALSE;
	}
	else 
		if (bOverlay==2) 
		{
			bPreview=2;
			bOverlay=1;
			CapWnd.Preview(FALSE);
			CapWnd.bOverlay=TRUE;
			CapWnd.bLive=FALSE;
			CapWnd.PreviewRate(0);
			CapWnd.Overlay(TRUE);
			
		}
}


void CVidCapPlusView::OnCaptureSingleframe() 
{
	// TODO: Add your command handler code here
	 CapWnd.Preview(FALSE);
	 CapWnd.Overlay(FALSE);
	 CapWnd.bLive=FALSE;
	 CapWnd.bOverlay=FALSE;
	 bOverlay=2;
	 bPreview=2;
     CapWnd.GrabFrameNoStop();
}


void CVidCapPlusView::OnCaptureVideo() 
{
	// Invoke a Dlg box to setup all the params
    CVideoCapParams dlg;
	if(dlg.DoModal()==IDOK)
	{
		CAPTUREPARMS CapParms;
		CapWnd.CaptureGetSetup(CapParms);
		CapParms.dwRequestMicroSecPerFrame=DWORD(1.0E6/float(dlg.iFrames));
		CapParms.fCaptureAudio           = dlg.m_Audio;
		CapParms.wNumVideoRequested      = (dlg.m_CaptureTo==0 ? 32 : 1000);
		CapParms.fMakeUserHitOKToCapture = TRUE;
		CapParms.fAbortLeftMouse         = FALSE;
        CapParms.fAbortRightMouse        = TRUE;
		CapParms.wPercentDropForError    = 10;
		CapParms.wChunkGranularity       =  0;
		CapParms.fYield					 = FALSE;
		CapParms.fLimitEnabled			 = dlg.m_TimeLimit;
		CapParms.wTimeLimit				 = dlg.iSeconds;
		CapWnd.CaptureSetSetup(CapParms);
		if (lstrlen(CapWnd.CaptureFile) != 0) 
			CapWnd.CaptureSequence();
	}
}

void CVidCapPlusView::OnCapturePalette() 
{
	// TODO: Add your command handler code here
	CapWnd.PaletteAuto(50, 256) ;
}

void CVidCapPlusView::OnUpdateCaptureSingleframe(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(bCreated ? TRUE : FALSE);
}

void CVidCapPlusView::OnUpdateEditCopy(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(bCreated ? TRUE : FALSE);
}

void CVidCapPlusView::OnUpdateEditPastepallete(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(bCreated ? TRUE : FALSE);
}

void CVidCapPlusView::OnUpdateOptionsAudioformat(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	
}

void CVidCapPlusView::OnUpdateOptionsVideoFormat(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(CapWnd.HasDlgVideoFormat() ? TRUE : FALSE);
}

void CVidCapPlusView::OnUpdateOptionsVideoSource(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(CapWnd.HasDlgVideoSource() ? TRUE : FALSE);
}

void CVidCapPlusView::OnUpdateOptionsVideoDisplay(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(CapWnd.HasDlgVideoDisplay() ? TRUE : FALSE);	
}

void CVidCapPlusView::OnUpdateOptionsVideoCompression(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	
}

void CVidCapPlusView::OnUpdateOptionsPreview(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable( (bPreview>0) ?  TRUE : FALSE);
	if (bPreview==1) pCmdUI->SetCheck(1);
	if (bPreview==2) pCmdUI->SetCheck(0);

}

void CVidCapPlusView::OnUpdateOptionsOverlay(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable( (CapWnd.HasOverlay()) ?  TRUE : FALSE);
	if (bOverlay==1) pCmdUI->SetCheck(1);
	if (bOverlay==2) pCmdUI->SetCheck(0);
}

void CVidCapPlusView::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	// TODO: Add your message handler code here
	
}



void CVidCapPlusView::ResizeView()
{
	CSize sizeTotal;
	RECT rect;
	// TODO: calculate the total size of this view
	for (int i=1;i<4;i++)
	{
		CapWnd.GetWindowRect(&rect);
		sizeTotal.cx = int(rect.right-rect.left);
		sizeTotal.cy = int(rect.bottom-rect.top);
		SetScrollSizes(MM_TEXT, sizeTotal);
		GetParentFrame()->RecalcLayout();
		ResizeParentToFit(FALSE);
	}
}

